package SoftLib.constraints;

import JaCoP.constraints.Constraint;
import JaCoP.constraints.ExtensionalSupportMDD;
import JaCoP.core.*;
import JaCoP.util.MDD;
import SoftLib.core.CoupleConstraint;
import SoftLib.core.SoftStore;
import SoftLib.weight.PrimitiveBinaryWeight;
import SoftLib.weight.PrimitiveWeight;

public class SoftExtensionalSupportMDD extends ExtensionalSupportMDD 
                                            implements SoftConstraint,
                                                       SoftExtensionalSupport {
    
    private PrimitiveBinaryWeight w;
    
    public SoftExtensionalSupportMDD(MDD diagram) {
        super(diagram);
    }
    
    public SoftExtensionalSupportMDD(IntVar [] vars, int [][] table){
        super(vars, table);
    }
    
    @Override
    public void impose(Store store) {
        throw new UnsupportedOperationException("Not supported: to use soft constraints you have to define a SoftStore type store.");
    }

    @Override
    public void impose(SoftStore store, PrimitiveBinaryWeight w) {
        if(this.getList().length != 2){
            throw new IllegalArgumentException("SoftExtensionalSupportSTR can be used only with two variables");
        }
        this.w = w;
        Constraint cost = w.setWeight(store, this.getList()[0], this.getList()[1]);
        store.addToBinary(this.getList()[0], this.getList()[1], new CoupleConstraint(this, cost));
        super.impose(store);
    }
    
    @Override
    public PrimitiveWeight getWeight() {
        return w;
    }

    @Override
    public IntVar[] getList() {
        return this.mdd.vars;
    }
    
}