package SoftLib.constraints;

import JaCoP.constraints.Constraint;
import JaCoP.constraints.XneqY;
import JaCoP.core.IntVar;
import JaCoP.core.Store;
import SoftLib.core.CoupleConstraint;
import SoftLib.core.SoftStore;
import SoftLib.weight.PrimitiveBinaryWeight;
import SoftLib.weight.PrimitiveWeight;
import SoftLib.weight.WeightDistance;

public class SoftXneqY extends XneqY
                            implements SoftConstraint{

    public PrimitiveBinaryWeight w;
    
    public SoftXneqY(IntVar x, IntVar y) {
        super(x, y);
    }
    
    @Override
    public void impose(Store store) {
        throw new UnsupportedOperationException("Not supported: to use soft constraints you have to define a SoftStore type store.");
    }

    public void impose(SoftStore store) {
        this.impose(store, new WeightDistance()); //if no weight function is passed, we assume that the weight is equal to the distance between the two assigned values
    }

    public void impose(SoftStore store, PrimitiveBinaryWeight w) {
        this.w = w;
        Constraint cost = w.setWeight(store, x, y);
        store.addToBinary(x, y, new CoupleConstraint(this, cost));
        super.impose(store);
    }

    @Override
    public PrimitiveWeight getWeight() {
        return w;
    }
}