package SoftLib.core;

import JaCoP.constraints.ExtensionalSupportSTR;
import JaCoP.core.IntVar;
import JaCoP.core.Interval;
import java.util.ArrayList;
import java.util.HashMap;

/**
 * Class that contains all the weight constraints for a variables, expressed in numeric form.
 * This class is used by softArcConsitency() as an auxiliary data structure.
 */

public class WeightUnaryDomain {
    
    public ArrayList<Integer> xDom;
    public ArrayList<HashMap<Integer, Integer>> w;
    public ExtensionalSupportSTR weightCon;

    public WeightUnaryDomain(IntVar x) {
        this.xDom = new ArrayList<Integer>();
        this.w = new ArrayList<HashMap<Integer, Integer>>();
        
        Interval current;
        int index = 0;
        while((current = x.domain.getInterval(index++)) != null){
            for(int i=current.min(); i<=current.max(); i++){
                xDom.add(i);
            }
        }
    }
}
